template <typename T>
class zlist
{
	
	private:

		#include "znode.h"

		znode* head;
		znode* tail;

		unsigned int numelements;

	public:
		#include "ziterator.h"
		friend class ziterator;

		zlist()
		{
			head = NULL;
			tail = NULL;
			numelements = 0;
		}
		zlist(const zlist<T>& l)
		{
			head = NULL;
			tail = NULL;
			numelements = 0;
			for(ziterator itz = l.begin();itz!=l.end();itz++)
			{
				push_back((*itz));
				numelements++;
			}
		}
		~zlist()
		{
			while(head != NULL)
			{
				znode* current = head;
				head = head->next;
				delete current;
			}
			tail = NULL;
			numelements = 0;
		}
		ziterator begin(void)
		{
			return ziterator(this,head);
		}
		ziterator end(void)
		{
			if(tail != NULL)
			{
				return ziterator(this,tail->next);
			}
			return ziterator(this,NULL);
		}
		unsigned int size(void)
		{
			return numelements;
		}
		bool empty(void)
		{
			return !numelements;
		}
		void pop_front()
		{
			if(head != NULL)
			{
				znode* removed_node = head;
				head = head->next;
				delete removed_node;
				if(head != NULL)
				{
					head->prev = NULL;
				}
				else
				{
					tail = NULL;
				}
				numelements--;
			}
		}
		void pop_back()
		{
			if(tail != NULL)
			{
				znode* removed_node = tail;
				tail = tail->prev;
				delete removed_node;
				if(tail != NULL)
				{
					tail->next = NULL;
				}
				else
				{
					head = NULL;
				}
				numelements--;
			}
		}
		ziterator erase(ziterator pos)
		{
			if(empty())
			{
				//empty
			}
			if(pos == end())
			{
				//stuff
			}
			ziterator r = pos;
			++r;
			if(pos.current == head)
			{
				pop_front();
				return r;
			}
			else if(pos.current == tail)
			{
				pop_back();
				return r;
			}
			else
			{
				znode* rnode = pos.current;
				rnode->prev->next = rnode->next;
				rnode->next->prev = rnode->prev;
				delete rnode;
				return r;
			}
		}
		void push_back(const T& item)
		{
			if(tail != NULL)
			{
				//znode* node = new znode(item,tail,NULL);
				tail->next = new znode(item,tail,NULL);
				tail = tail->next;
				numelements++;
			}
			else //if tail is null (empty list)
			{
				tail = new znode(item, head, NULL);
				head = tail;
				numelements++;
			}
		}
};